Get data streams

  • GET /_data_stream/{name}
  • GET /_data_stream
Auth

Get information about one or more data streams.

Required privileges

Index privileges view_index_metadata

Path parameters

name union string | string[] optional

Comma-separated list of data stream names used to limit the request. Wildcard (*) expressions are supported. If omitted, all data streams are returned.

Leave it out to use /_data_stream.

Query parameters

expand_wildcards union oneOf · default: open

Type of data stream that wildcard patterns can match. Supports comma-separated values, such as open,hidden.

Supported values include:

  • all: Match any data stream or index, including hidden ones.
  • open: Match open, non-hidden indices. Also matches any non-hidden data stream.
  • closed: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
  • hidden: Match hidden data streams and hidden indices. Must be combined with open, closed, or both.
  • none: Wildcard expressions are not accepted.
Values: all open closed hidden none
include_defaults boolean · default: false

If true, returns all relevant default configurations for the index template.

master_timeout union oneOf · default: 30s

Period to wait for a connection to the master node. If no response is received before the timeout expires, the request fails and returns an error.

Values: -1 0
verbose boolean · default: false

Whether the maximum timestamp for each data stream should be calculated and returned.

Response

application/json
data_streams object[] required
_meta object

Custom metadata for the stream, copied from the _meta object of the stream’s matching index template. If empty, the response omits this property.

allow_custom_routing boolean

If true, the data stream allows custom routing on write request.

generation number required

Current generation for the data stream. This number acts as a cumulative count of the stream’s rollovers, starting at 1.

hidden boolean required

If true, the data stream is hidden.

ilm_policy string

Name of the current ILM lifecycle policy in the stream’s matching index template. This lifecycle policy is set in the index.lifecycle.name setting. If the template does not include a lifecycle policy, this property is not included in the response. NOTE: A data stream’s backing indices may be assigned different lifecycle policies. To retrieve the lifecycle policy for individual backing indices, use the get index settings API.

next_generation_managed_by enum required

Name of the lifecycle system that'll manage the next generation of the data stream.

Values: Index Lifecycle Management Data stream lifecycle Unmanaged
prefer_ilm boolean required

Indicates if ILM should take precedence over DSL in case both are configured to managed this data stream.

indices object[] required

Array of objects containing information about the data stream’s backing indices. The last item in this array contains information about the stream’s current write index.

index_name string required

Name of the backing index.

index_uuid string required

Universally unique identifier (UUID) for the index.

ilm_policy string

Name of the current ILM lifecycle policy configured for this backing index.

managed_by enum

Name of the lifecycle system that's currently managing this backing index.

Values: Index Lifecycle Management Data stream lifecycle Unmanaged
prefer_ilm boolean

Indicates if ILM should take precedence over DSL in case both are configured to manage this index.

index_mode enum

The index mode of this backing index of the data stream.

Values: standard time_series logsdb lookup
name string required

Name of the data stream.

replicated boolean

If true, the data stream is created and managed by cross-cluster replication and the local cluster can not write into this data stream or change its mappings.

rollover_on_write boolean required

If true, the next write to this data stream will trigger a rollover first and the document will be indexed in the new backing index. If the rollover fails the indexing request will fail too.

settings object required

The settings specific to this data stream that will take precedence over the settings in the matching index template.

index object
Same fields as settings in data_streams
mode string
routing_path union string | string[]
number_of_routing_shards number
check_on_startup enum · default: false
Values: true false checksum
codec string · default: LZ4
routing_partition_size number | string · default: 1
load_fixed_bitset_filters_eagerly boolean · default: true
hidden boolean | string · default: false
auto_expand_replicas union string · default: false nullable
refresh_interval union oneOf · default: 1s
Values: -1 0
max_result_window number | string · default: 10000
max_inner_result_window number · default: 100
max_rescore_window number · default: 10000
max_script_fields number · default: 32
max_ngram_diff number · default: 1
max_shingle_diff number · default: 3
max_refresh_listeners number
max_terms_count number · default: 65536
max_regex_length number · default: 1000
gc_deletes union oneOf · default: 60s
Values: -1 0
default_pipeline string · default: _none
final_pipeline string · default: _none
provided_name string
creation_date union oneOf
One of: number or string
creation_date_string union oneOf
One of: string or number
uuid string
verified_before_close boolean | string
format number | string
max_slices_per_scroll number
priority number | string
top_metrics_max_size number
settings object
Same fields as settings in data_streams
similarity map string to oneOf

Configure custom similarity settings to customize how search results are scored.

status enum required

Health status of the data stream. This health status is based on the state of the primary and replica shards of the stream’s backing indices.

Supported values include:

  • green (or GREEN): All shards are assigned.
  • yellow (or YELLOW): All primary shards are assigned, but one or more replica shards are unassigned. If a node in the cluster fails, some data could be unavailable until that node is repaired.
  • red (or RED): One or more primary shards are unassigned, so some data is unavailable. This can occur briefly during cluster startup as primary shards are assigned.
  • unknown
  • unavailable
Values: green GREEN yellow YELLOW red RED unknown unavailable
system boolean

If true, the data stream is created and managed by an Elastic stack component and cannot be modified through normal user interaction.

template string required

Name of the index template used to create the data stream’s backing indices. The template’s index pattern must match the name of this data stream.

timestamp_field object required

Information about the @timestamp field in the data stream.

name string required

Name of the timestamp field for the data stream, which must be @timestamp. The @timestamp field must be included in every document indexed to the data stream.

index_mode enum

The index mode for the data stream that will be used for newly created backing indices.

Values: standard time_series logsdb lookup